Index: src/Actions/FragmentationAction/ConstructBondGraphAction.cpp
===================================================================
--- src/Actions/FragmentationAction/ConstructBondGraphAction.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/Actions/FragmentationAction/ConstructBondGraphAction.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -97,5 +97,5 @@
     LC = new LinkedCell(cloud, BondDistance);
 
-    // create a list to map Tesselpoint::ParticleInfo_nr to atom *
+    // create a list to map Tesselpoint::Nr to atom *
     DoLog(2) && (Log() << Verbose(2) << "Creating TesselPoint to atom map ... " << endl);
 
Index: src/BoundaryPointSet.cpp
===================================================================
--- src/BoundaryPointSet.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/BoundaryPointSet.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -71,5 +71,5 @@
 {
   Info FunctionInfo(__func__);
-  //Log() << Verbose(0) << "Erasing point ParticleInfo_nr. " << Nr << "." << endl;
+  //Log() << Verbose(0) << "Erasing point Nr. " << Nr << "." << endl;
   if (!lines.empty())
     DoeLog(2) && (eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some lines." << endl);
Index: src/BoundaryPointSet.hpp
===================================================================
--- src/BoundaryPointSet.hpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/BoundaryPointSet.hpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -50,5 +50,5 @@
     const Vector& getPosition() const;
 
-    /** Getter for \a node's ParticleInfo_nr.
+    /** Getter for \a node's Nr.
      *
      * @return getNr() of \a node
Index: src/Helpers/helpers.hpp
===================================================================
--- src/Helpers/helpers.hpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/Helpers/helpers.hpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -78,5 +78,5 @@
   if (count == 0) {
     Walker = start;
-    while (Walker->next != end) { // create a lookup table (Atom::ParticleInfo_nr -> atom) used as a marker table lateron
+    while (Walker->next != end) { // create a lookup table (Atom::Nr -> atom) used as a marker table lateron
       Walker = Walker->next;
       count = (count < Walker->GetTrueFather()->nr) ? Walker->GetTrueFather()->nr : count;
@@ -96,5 +96,5 @@
   } else {
     Walker = start;
-    while (Walker->next != end) { // create a lookup table (Atom::ParticleInfo_nr -> atom) used as a marker table lateron
+    while (Walker->next != end) { // create a lookup table (Atom::Nr -> atom) used as a marker table lateron
       Walker = Walker->next;
       AtomNo = Walker->GetTrueFather()->nr;
Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/atom.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -40,5 +40,5 @@
 atom::atom() :
   father(this),
-  sort(&ParticleInfo_nr),
+  sort(&Nr),
   mol(0)
 {};
@@ -49,5 +49,5 @@
     ParticleInfo(pointer),
     father(pointer),
-    sort(&ParticleInfo_nr),
+    sort(&Nr),
     mol(0)
 {
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/atom_bondedparticle.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -68,5 +68,5 @@
 };
 
-/** Output of atom::ParticleInfo_nr along with all bond partners.
+/** Output of atom::Nr along with all bond partners.
  * \param *AdjacencyFile output stream
  */
@@ -80,6 +80,6 @@
 };
 
-/** Output of atom::ParticleInfo_nr along each bond partner per line.
- * Only bonds are printed where atom::ParticleInfo_nr is smaller than the one of the bond partner.
+/** Output of atom::Nr along each bond partner per line.
+ * Only bonds are printed where atom::Nr is smaller than the one of the bond partner.
  * \param *AdjacencyFile output stream
  */
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/atom_particleinfo.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -27,10 +27,10 @@
  */
 ParticleInfo::ParticleInfo() :
-  ParticleInfo_nr(-1),
+  Nr(-1),
   name("Unknown")
 {};
 
 ParticleInfo::ParticleInfo(ParticleInfo *pointer) :
-  ParticleInfo_nr(pointer->ParticleInfo_nr),
+  Nr(pointer->Nr),
   name(pointer->name)
 {}
@@ -58,10 +58,10 @@
 const int& ParticleInfo::getNr() const
 {
-  return ParticleInfo_nr;
+  return Nr;
 }
 
 void ParticleInfo::setNr(const int newnr)
 {
-  ParticleInfo_nr = newnr;
+  Nr = newnr;
 }
 
Index: src/atom_particleinfo.hpp
===================================================================
--- src/atom_particleinfo.hpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/atom_particleinfo.hpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -37,10 +37,10 @@
    */
   const std::string& getName() const;
-  /** Getter for ParticleInfo_nr.
+  /** Getter for Nr.
    *
    * @return number of particle
    */
   const int& getNr() const;
-  /** Setter for ParticleInfo_nr.
+  /** Setter for Nr.
    *
    * @param newnr number of particle
@@ -56,5 +56,5 @@
 
 protected:
-  int ParticleInfo_nr;       // index to easierly identify, only protected as used in atom::sort
+  int Nr;       // index to easierly identify, only protected as used in atom::sort
 
 private:
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/bond.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -115,5 +115,5 @@
 
 /** Checks if an atom exists in a bond.
- * \param ParticleInfo_nr index of atom
+ * \param Nr index of atom
  * \return true if it is either bond::leftatom or bond::rightatom, false otherwise
  */
Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/boundary.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -174,5 +174,5 @@
   Vector AngleReferenceNormalVector;
   Vector ProjectedVector;
-  Boundaries *BoundaryPoints = new Boundaries[NDIM]; // first is alpha, second is (r, ParticleInfo_nr)
+  Boundaries *BoundaryPoints = new Boundaries[NDIM]; // first is alpha, second is (r, Nr)
   double angle = 0.;
 
Index: src/ellipsoid.cpp
===================================================================
--- src/ellipsoid.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/ellipsoid.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -317,5 +317,5 @@
       current = PickedAtomNrs.find(index);  // not present?
       if (current == PickedAtomNrs.end()) {
-        //Log() << Verbose(2) << "Picking atom ParticleInfo_nr. " << index << "." << endl;
+        //Log() << Verbose(2) << "Picking atom Nr. " << index << "." << endl;
         PickedAtomNrs.insert(index);
       }
@@ -342,5 +342,5 @@
                 current++;    // next pre-picked atom
               }
-              index++;  // next atom ParticleInfo_nr.
+              index++;  // next atom Nr.
             }
 //          } else {
Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/molecule_fragmentation.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -351,5 +351,5 @@
 
   if (CountLinesinFile(InputFile) > 0) {
-    // each line represents a fragment root (Atom::ParticleInfo_nr) id and its energy contribution
+    // each line represents a fragment root (Atom::Nr) id and its energy contribution
     InputFile.getline(buffer, MAXSTRINGSIZE); // skip comment lines
     InputFile.getline(buffer, MAXSTRINGSIZE);
@@ -411,5 +411,5 @@
  * Picks a given number of highest values and set *AtomMask to true.
  * \param *out output stream for debugging
- * \param *AtomMask defines true/false per global Atom::ParticleInfo_nr to mask in/out each nuclear site, used to activate given number of site to increment order adaptively
+ * \param *AtomMask defines true/false per global Atom::Nr to mask in/out each nuclear site, used to activate given number of site to increment order adaptively
  * \param FinalRootCandidates list candidates to check
  * \param Order desired order
@@ -437,5 +437,5 @@
 /** print atom mask for debugging.
  * \param *out output stream for debugging
- * \param *AtomMask defines true/false per global Atom::ParticleInfo_nr to mask in/out each nuclear site, used to activate given number of site to increment order adaptively
+ * \param *AtomMask defines true/false per global Atom::Nr to mask in/out each nuclear site, used to activate given number of site to increment order adaptively
  * \param AtomCount number of entries in \a *AtomMask
  */
@@ -453,5 +453,5 @@
 
 /** Checks whether the OrderAtSite is still below \a Order at some site.
- * \param *AtomMask defines true/false per global Atom::ParticleInfo_nr to mask in/out each nuclear site, used to activate given number of site to increment order adaptively
+ * \param *AtomMask defines true/false per global Atom::Nr to mask in/out each nuclear site, used to activate given number of site to increment order adaptively
  * \param *GlobalKeySetList list of keysets with global ids (valid in "this" molecule) needed for adaptive increase
  * \param Order desired Order if positive, desired exponent in threshold criteria if negative (0 is single-step)
@@ -574,5 +574,5 @@
   // count them
   if (count == 0) {
-    for (molecule::iterator iter = begin(); iter != end(); ++iter) { // create a lookup table (Atom::ParticleInfo_nr -> atom) used as a marker table lateron
+    for (molecule::iterator iter = begin(); iter != end(); ++iter) { // create a lookup table (Atom::Nr -> atom) used as a marker table lateron
       count = (count < (*iter)->GetTrueFather()->getNr()) ? (*iter)->GetTrueFather()->getNr() : count;
     }
@@ -655,5 +655,5 @@
   // ===== 1. Check whether bond structure is same as stored in files ====
 
-  // create lookup table for Atom::ParticleInfo_nr
+  // create lookup table for Atom::Nr
   FragmentationToDo = FragmentationToDo && CreateFatherLookupTable(ListOfAtoms, getAtomCount());
 
@@ -854,5 +854,5 @@
 
 
-/** Stores pairs (Atom::ParticleInfo_nr, Atom::AdaptiveOrder) into file.
+/** Stores pairs (Atom::Nr, Atom::AdaptiveOrder) into file.
  * Atoms not present in the file get "-1".
  * \param &path path to file ORDERATSITEFILE
@@ -878,5 +878,5 @@
 };
 
-/** Parses pairs(Atom::ParticleInfo_nr, Atom::AdaptiveOrder) from file and stores in molecule's Atom's.
+/** Parses pairs(Atom::Nr, Atom::AdaptiveOrder) from file and stores in molecule's Atom's.
  * Atoms not present in the file get "0".
  * \param &path path to file ORDERATSITEFILEe
@@ -1018,5 +1018,5 @@
         if (SonList[OtherFather->getNr()] != NULL) {
 //          Log() << Verbose(0) << ", whose son is " << *SonList[OtherFather->getNr()] << "." << endl;
-          if (OtherFather->getNr() > FatherOfRunner->getNr()) { // add bond (ParticleInfo_nr check is for adding only one of both variants: ab, ba)
+          if (OtherFather->getNr() > FatherOfRunner->getNr()) { // add bond (Nr check is for adding only one of both variants: ab, ba)
 //            Log() << Verbose(3) << "Adding Bond: ";
 //            Log() << Verbose(0) <<
Index: src/molecule_graph.cpp
===================================================================
--- src/molecule_graph.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/molecule_graph.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -165,5 +165,5 @@
     LC = new LinkedCell(cloud, bonddistance);
 
-    // create a list to map Tesselpoint::ParticleInfo_nr to atom *
+    // create a list to map Tesselpoint::Nr to atom *
     DoLog(2) && (Log() << Verbose(2) << "Creating TesselPoint to atom map ... " << endl);
 
@@ -1025,5 +1025,5 @@
  * This is O(N) as the number of bonds per atom is bound.
  * \param *vertex atom whose next atom::*ComponentNr is to be set
- * \param ParticleInfo_nr number to use
+ * \param Nr number to use
  */
 void molecule::SetNextComponentNumber(atom *vertex, int nr) const
@@ -1095,5 +1095,5 @@
 
 /** Storing the bond structure of a molecule to file.
- * Simply stores Atom::ParticleInfo_nr and then the Atom::ParticleInfo_nr of all bond partners per line.
+ * Simply stores Atom::Nr and then the Atom::Nr of all bond partners per line.
  * \param &filename name of file
  * \param path path to file, defaults to empty
@@ -1127,5 +1127,5 @@
 
 /** Storing the bond structure of a molecule to file.
- * Simply stores Atom::ParticleInfo_nr and then the Atom::ParticleInfo_nr of all bond partners, one per line.
+ * Simply stores Atom::Nr and then the Atom::Nr of all bond partners, one per line.
  * \param &filename name of file
  * \param path path to file, defaults to empty
@@ -1217,5 +1217,5 @@
 /** Checks contents of adjacency file against bond structure in structure molecule.
  * \param *path path to file
- * \param **ListOfAtoms allocated (molecule::AtomCount) and filled lookup table for ids (Atom::ParticleInfo_nr) to *Atom
+ * \param **ListOfAtoms allocated (molecule::AtomCount) and filled lookup table for ids (Atom::Nr) to *Atom
  * \return true - structure is equal, false - not equivalence
  */
@@ -1273,5 +1273,5 @@
 
 /** Picks from a global stack with all back edges the ones in the fragment.
- * \param **ListOfLocalAtoms array of father atom::ParticleInfo_nr to local atom::ParticleInfo_nr (reverse of atom::father)
+ * \param **ListOfLocalAtoms array of father atom::Nr to local atom::Nr (reverse of atom::father)
  * \param *ReferenceStack stack with all the back egdes
  * \param *LocalStack stack to be filled
Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/moleculelist.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -837,5 +837,5 @@
  * \param *out output stream for debugging
  * \param *&RootStack stack to be filled
- * \param *AtomMask defines true/false per global Atom::ParticleInfo_nr to mask in/out each nuclear site
+ * \param *AtomMask defines true/false per global Atom::Nr to mask in/out each nuclear site
  * \param &FragmentCounter counts through the fragments in this MoleculeLeafClass
  * \return true - stack is non-empty, fragmentation necessary, false - stack is empty, no more sites to update
@@ -871,5 +871,5 @@
 };
 
-/** Fills a lookup list of father's Atom::ParticleInfo_nr -> atom for each subgraph.
+/** Fills a lookup list of father's Atom::Nr -> atom for each subgraph.
  * \param *out output stream from debugging
  * \param **&ListOfLocalAtoms Lookup table for each subgraph and index of each atom in global molecule, may be NULL on start, then it is filled
@@ -891,5 +891,5 @@
 };
 
-/** The indices per keyset are compared to the respective father's Atom::ParticleInfo_nr in each subgraph and thus put into \a **&FragmentList.
+/** The indices per keyset are compared to the respective father's Atom::Nr in each subgraph and thus put into \a **&FragmentList.
  * \param *out output stream fro debugging
  * \param *reference reference molecule with the bond structure to be copied
Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/parser.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -765,5 +765,5 @@
       }
     }
-    RowCounter[MatrixCounter]++;    // ParticleInfo_nr start at 0, count starts at 1
+    RowCounter[MatrixCounter]++;    // Nr start at 0, count starts at 1
     input.close();
 
@@ -1000,6 +1000,6 @@
       }
     }
-    RowCounter[MatrixCounter]++;    // ParticleInfo_nr start at 0, count starts at 1
-    ColumnCounter[MatrixCounter]++;    // ParticleInfo_nr start at 0, count starts at 1
+    RowCounter[MatrixCounter]++;    // Nr start at 0, count starts at 1
+    ColumnCounter[MatrixCounter]++;    // Nr start at 0, count starts at 1
     input.close();
   
Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 735b1c1514f0f9ac27c1a3ef683b9fa6ea2cf010)
+++ src/tesselation.cpp	(revision 5309ba2259d81aba279e4520a5ebc51c898d8b75)
@@ -708,5 +708,5 @@
 
 /** Function adds triangle to global list.
- * Furthermore, the triangle number is set to \a ParticleInfo_nr.
+ * Furthermore, the triangle number is set to \a Nr.
  * \param getNr() triangle number
  */