Index: src/Actions/ShapeAction/CombineShapesAction.cpp
===================================================================
--- src/Actions/ShapeAction/CombineShapesAction.cpp	(revision 12098a4b39967b9685cdc4ee1bad7bc1723f2073)
+++ src/Actions/ShapeAction/CombineShapesAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -51,5 +51,5 @@
 #include "Action_impl_pre.hpp"
 /** =========== define the function ====================== */
-Action::state_ptr ShapeCombineShapesAction::performCall() {
+ActionState::ptr ShapeCombineShapesAction::performCall() {
   LOG(1, "Combining shapes in ShapeRegistry.");
 
@@ -88,8 +88,8 @@
   ShapeRegistry::getInstance().addShape(s);
 
-  return Action::state_ptr(new ShapeCombineShapesState(old_name, params));
+  return ActionState::ptr(new ShapeCombineShapesState(old_name, params));
 }
 
-Action::state_ptr ShapeCombineShapesAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr ShapeCombineShapesAction::performUndo(ActionState::ptr _state) {
   ShapeCombineShapesState *state = assert_cast<ShapeCombineShapesState*>(_state.get());
 
@@ -99,8 +99,8 @@
   ShapeRegistry::getInstance().removeShape(state->old_name);
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
-Action::state_ptr ShapeCombineShapesAction::performRedo(Action::state_ptr _state){
+ActionState::ptr ShapeCombineShapesAction::performRedo(ActionState::ptr _state){
   ShapeCombineShapesState *state = assert_cast<ShapeCombineShapesState*>(_state.get());
 
@@ -134,5 +134,5 @@
   ShapeRegistry::getInstance().addShape(s);
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
Index: src/Actions/ShapeAction/CreateShapeAction.cpp
===================================================================
--- src/Actions/ShapeAction/CreateShapeAction.cpp	(revision 12098a4b39967b9685cdc4ee1bad7bc1723f2073)
+++ src/Actions/ShapeAction/CreateShapeAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -51,5 +51,5 @@
 #include "Action_impl_pre.hpp"
 /** =========== define the function ====================== */
-Action::state_ptr ShapeCreateShapeAction::performCall() {
+ActionState::ptr ShapeCreateShapeAction::performCall() {
   LOG(1, "Adding shape into ShapeRegistry.");
 
@@ -65,8 +65,8 @@
   ShapeRegistry::getInstance().addShape(s);
 
-  return Action::state_ptr(new ShapeCreateShapeState(old_name, params));
+  return ActionState::ptr(new ShapeCreateShapeState(old_name, params));
 }
 
-Action::state_ptr ShapeCreateShapeAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr ShapeCreateShapeAction::performUndo(ActionState::ptr _state) {
   ShapeCreateShapeState *state = assert_cast<ShapeCreateShapeState*>(_state.get());
 
@@ -76,8 +76,8 @@
   ShapeRegistry::getInstance().removeShape(state->old_name);
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
-Action::state_ptr ShapeCreateShapeAction::performRedo(Action::state_ptr _state){
+ActionState::ptr ShapeCreateShapeAction::performRedo(ActionState::ptr _state){
   ShapeCreateShapeState *state = assert_cast<ShapeCreateShapeState*>(_state.get());
 
@@ -93,5 +93,5 @@
   ShapeRegistry::getInstance().addShape(s);
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
Index: src/Actions/ShapeAction/RemoveShapeAction.cpp
===================================================================
--- src/Actions/ShapeAction/RemoveShapeAction.cpp	(revision 12098a4b39967b9685cdc4ee1bad7bc1723f2073)
+++ src/Actions/ShapeAction/RemoveShapeAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -51,5 +51,5 @@
 #include "Action_impl_pre.hpp"
 /** =========== define the function ====================== */
-Action::state_ptr ShapeRemoveShapeAction::performCall() {
+ActionState::ptr ShapeRemoveShapeAction::performCall() {
   LOG(1, "Removing shapes from ShapeRegistry.");
 
@@ -62,8 +62,8 @@
   }
 
-  return Action::state_ptr(new ShapeRemoveShapeState(old_shapes, params));
+  return ActionState::ptr(new ShapeRemoveShapeState(old_shapes, params));
 }
 
-Action::state_ptr ShapeRemoveShapeAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr ShapeRemoveShapeAction::performUndo(ActionState::ptr _state) {
   ShapeRemoveShapeState *state = assert_cast<ShapeRemoveShapeState*>(_state.get());
 
@@ -75,8 +75,8 @@
   }
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
-Action::state_ptr ShapeRemoveShapeAction::performRedo(Action::state_ptr _state){
+ActionState::ptr ShapeRemoveShapeAction::performRedo(ActionState::ptr _state){
   ShapeRemoveShapeState *state = assert_cast<ShapeRemoveShapeState*>(_state.get());
 
@@ -85,5 +85,5 @@
     ShapeRegistry::getInstance().removeShape(selectedShapes[i]->getName());
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
Index: src/Actions/ShapeAction/RotateShapeAction.cpp
===================================================================
--- src/Actions/ShapeAction/RotateShapeAction.cpp	(revision 12098a4b39967b9685cdc4ee1bad7bc1723f2073)
+++ src/Actions/ShapeAction/RotateShapeAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -51,5 +51,5 @@
 #include "Action_impl_pre.hpp"
 /** =========== define the function ====================== */
-Action::state_ptr ShapeRotateShapeAction::performCall() {
+ActionState::ptr ShapeRotateShapeAction::performCall() {
   LOG(1, "Translating shapes in ShapeRegistry.");
 
@@ -72,8 +72,8 @@
   }
 
-  return Action::state_ptr(new ShapeRotateShapeState(old_shapes, params));
+  return ActionState::ptr(new ShapeRotateShapeState(old_shapes, params));
 }
 
-Action::state_ptr ShapeRotateShapeAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr ShapeRotateShapeAction::performUndo(ActionState::ptr _state) {
   ShapeRotateShapeState *state = assert_cast<ShapeRotateShapeState*>(_state.get());
 
@@ -85,8 +85,8 @@
   }
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
-Action::state_ptr ShapeRotateShapeAction::performRedo(Action::state_ptr _state){
+ActionState::ptr ShapeRotateShapeAction::performRedo(ActionState::ptr _state){
   ShapeRotateShapeState *state = assert_cast<ShapeRotateShapeState*>(_state.get());
 
@@ -106,5 +106,5 @@
   }
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
Index: src/Actions/ShapeAction/StretchShapeAction.cpp
===================================================================
--- src/Actions/ShapeAction/StretchShapeAction.cpp	(revision 12098a4b39967b9685cdc4ee1bad7bc1723f2073)
+++ src/Actions/ShapeAction/StretchShapeAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -51,5 +51,5 @@
 #include "Action_impl_pre.hpp"
 /** =========== define the function ====================== */
-Action::state_ptr ShapeStretchShapeAction::performCall() {
+ActionState::ptr ShapeStretchShapeAction::performCall() {
   LOG(1, "Translating shapes in ShapeRegistry.");
 
@@ -72,8 +72,8 @@
   }
 
-  return Action::state_ptr(new ShapeStretchShapeState(old_shapes, params));
+  return ActionState::ptr(new ShapeStretchShapeState(old_shapes, params));
 }
 
-Action::state_ptr ShapeStretchShapeAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr ShapeStretchShapeAction::performUndo(ActionState::ptr _state) {
   ShapeStretchShapeState *state = assert_cast<ShapeStretchShapeState*>(_state.get());
 
@@ -85,8 +85,8 @@
   }
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
-Action::state_ptr ShapeStretchShapeAction::performRedo(Action::state_ptr _state){
+ActionState::ptr ShapeStretchShapeAction::performRedo(ActionState::ptr _state){
   ShapeStretchShapeState *state = assert_cast<ShapeStretchShapeState*>(_state.get());
 
@@ -106,5 +106,5 @@
   }
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
Index: src/Actions/ShapeAction/TranslateShapeAction.cpp
===================================================================
--- src/Actions/ShapeAction/TranslateShapeAction.cpp	(revision 12098a4b39967b9685cdc4ee1bad7bc1723f2073)
+++ src/Actions/ShapeAction/TranslateShapeAction.cpp	(revision 6367dd4c64d4b033c174ad1c6226bf1e34ef0e7c)
@@ -51,5 +51,5 @@
 #include "Action_impl_pre.hpp"
 /** =========== define the function ====================== */
-Action::state_ptr ShapeTranslateShapeAction::performCall() {
+ActionState::ptr ShapeTranslateShapeAction::performCall() {
   LOG(1, "Translating shapes in ShapeRegistry.");
 
@@ -68,8 +68,8 @@
   }
 
-  return Action::state_ptr(new ShapeTranslateShapeState(old_shapes, params));
+  return ActionState::ptr(new ShapeTranslateShapeState(old_shapes, params));
 }
 
-Action::state_ptr ShapeTranslateShapeAction::performUndo(Action::state_ptr _state) {
+ActionState::ptr ShapeTranslateShapeAction::performUndo(ActionState::ptr _state) {
   ShapeTranslateShapeState *state = assert_cast<ShapeTranslateShapeState*>(_state.get());
 
@@ -81,8 +81,8 @@
   }
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 
-Action::state_ptr ShapeTranslateShapeAction::performRedo(Action::state_ptr _state){
+ActionState::ptr ShapeTranslateShapeAction::performRedo(ActionState::ptr _state){
   ShapeTranslateShapeState *state = assert_cast<ShapeTranslateShapeState*>(_state.get());
 
@@ -98,5 +98,5 @@
   }
 
-  return Action::state_ptr(_state);
+  return ActionState::ptr(_state);
 }
 