Index: src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp
===================================================================
--- src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp	(revision 6499b1ee9307f8ecc39caafba8f8083e036a4bd0)
+++ src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp	(revision 6499b1ee9307f8ecc39caafba8f8083e036a4bd0)
@@ -0,0 +1,88 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * IsInsideDomain_FillPredicateUnitTest.cpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "Box.hpp"
+#include "Filling/Predicates/IsInsideDomain_FillPredicate.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "Filling/NodeTypes.hpp"
+
+#include "IsInsideDomain_FillPredicateUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( IsInsideDomain_FillPredicateTest );
+
+
+void IsInsideDomain_FillPredicateTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  M = new RealSpaceMatrix;
+  M->setIdentity();
+  (*M) *= 20.;
+
+  domain = new Box(*M);
+
+  predicate = new FillPredicate(IsInsideDomain_FillPredicate(*domain));
+}
+
+
+void IsInsideDomain_FillPredicateTest::tearDown()
+{
+  delete predicate;
+  delete domain;
+  delete M;
+}
+
+/** Test whether operator() returns as desired
+ *
+ */
+void IsInsideDomain_FillPredicateTest::operatorTest()
+{
+  Node origin(0.,0.,0.);
+  Node center(10.,10.,10.);
+  Node corner(20.,20.,20.);
+  Node outside(30.,30.,30.);
+
+  {
+    // origin is inside
+    CPPUNIT_ASSERT( (*predicate)(origin) );
+
+    // center is inside
+    CPPUNIT_ASSERT( (*predicate)(center) );
+
+    // corner is inside
+    CPPUNIT_ASSERT( (*predicate)(corner) );
+
+    // outside is outside
+    CPPUNIT_ASSERT( !(*predicate)(outside) );
+  }
+}
Index: src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp
===================================================================
--- src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp	(revision 6499b1ee9307f8ecc39caafba8f8083e036a4bd0)
+++ src/Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp	(revision 6499b1ee9307f8ecc39caafba8f8083e036a4bd0)
@@ -0,0 +1,42 @@
+/*
+ * IsInsideDomain_FillPredicateUnitTest.hpp
+ *
+ *  Created on: Jan 19, 2012
+ *      Author: heber
+ */
+
+#ifndef ISINSIDEDOMAIN_FILLPREDICATEUNITTEST_HPP_
+#define ISINSIDEDOMAIN_FILLPREDICATEUNITTEST_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class Box;
+class RealSpaceMatrix;
+class FillPredicate;
+
+/********************************************** Test classes **************************************/
+
+class IsInsideDomain_FillPredicateTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( IsInsideDomain_FillPredicateTest) ;
+    CPPUNIT_TEST ( operatorTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void operatorTest();
+
+private:
+      RealSpaceMatrix *M;
+      Box *domain;
+      FillPredicate *predicate;
+};
+
+#endif /* ISINSIDEDOMAIN_FILLPREDICATEUNITTEST_HPP_ */
Index: src/Filling/unittests/Makefile.am
===================================================================
--- src/Filling/unittests/Makefile.am	(revision 600a5296c7fb2bdb5ffe9f184edc5632d2acb442)
+++ src/Filling/unittests/Makefile.am	(revision 6499b1ee9307f8ecc39caafba8f8083e036a4bd0)
@@ -3,10 +3,13 @@
 
 FILLINGTESTSSOURCES = \
+  ../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp \
   ../Filling/unittests/IsValidInDomain_FillPredicateUnitTest.cpp
 
 FILLINGTESTSHEADERS = \
+  ../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp \
   ../Filling/unittests/IsValidInDomain_FillPredicateUnitTest.hpp
 
 FILLINGTESTS = \
+  IsInsideDomain_FillPredicateUnitTest \
   IsValidInDomain_FillPredicateUnitTest
 
@@ -16,4 +19,15 @@
 
 FILLINGLIBS =
+
+IsInsideDomain_FillPredicateUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.cpp \
+	../Filling/unittests/IsInsideDomain_FillPredicateUnitTest.hpp
+IsInsideDomain_FillPredicateUnitTest_LDADD = \
+	../libMolecuilderFilling.la \
+	../libMolecuilderUI.la \
+	../libMolecuilder.la \
+	$(top_builddir)/LinearAlgebra/src/LinearAlgebra/libLinearAlgebra.la \
+	${CodePatterns_LIBS} \
+	$(BOOST_LIBS)
 
 IsValidInDomain_FillPredicateUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \