Index: src/Fragmentation/Automation/Makefile.am
===================================================================
--- src/Fragmentation/Automation/Makefile.am	(revision 311137ba72b2a6d1e9387251b02ad24abd7810de)
+++ src/Fragmentation/Automation/Makefile.am	(revision 7546b0b65f515aa9912563671305e96bb443e945)
@@ -10,4 +10,5 @@
 noinst_PROGRAMS =
 noinst_LTLIBRARIES =
+lib_LTLIBRARIES =
 
 # PLEASE adhere to the alphabetical ordering in this Makefile!
@@ -41,4 +42,5 @@
   Operations/AsyncOperation.cpp \
   Operations/OperationQueue.cpp \
+  Operations/OperationRegistry.cpp \
   Operations/SyncOperation.cpp \
   Operations/Controllers/CheckResultsOperation.cpp \
@@ -60,4 +62,5 @@
   Operations/Operation.hpp \
   Operations/OperationQueue.hpp \
+  Operations/OperationRegistry.hpp \
   Operations/SyncOperation.hpp \
   Operations/Controllers/CheckResultsOperation.hpp \
@@ -100,4 +103,74 @@
 libMolecuilderFragmentationAutomationHelper_la_SOURCES = $(FRAGMENTATIONAUTOMATIONHELPERSOURCE)
 
+
+lib_LTLIBRARIES += libFragmentationAutomation.la
+# make libtool link with C++ linker
+nodist_EXTRA_libFragmentationAutomation_la_SOURCES = dummy.cpp
+libFragmentationAutomation_la_includedir = $(includedir)/MoleCuilder/FragmentationAutomation/
+libFragmentationAutomation_la_LIBADD = \
+        libMolecuilderFragmentJobs.la \
+        libMolecuilderFragmentationOperations.la \
+        libMolecuilderFragmentationAutomationHelper.la \
+        $(BOOST_ASIO_LDFLAGS) $(BOOST_ASIO_LIBS) \
+        $(BOOST_PROGRAM_OPTIONS_LDFLAGS) $(BOOST_PROGRAM_OPTIONS_LIBS) \
+        $(BOOST_SERIALIZATION_LDFLAGS) $(BOOST_SERIALIZATION_LIBS) \
+        $(BOOST_THREAD_LDFLAGS) $(BOOST_THREAD_LIBS) \
+        $(BOOST_IOSTREAMS_LDFLAGS) $(BOOST_IOSTREAMS_LIBS) \
+        $(BOOST_FILESYSTEM_LDFLAGS) $(BOOST_FILESYSTEM_LIBS) \
+        $(BOOST_SYSTEM_LDFLAGS) $(BOOST_SYSTEM_LIBS) \
+        ${CodePatterns_LIBS}
+nobase_libFragmentationAutomation_la_include_HEADERS = \
+        $(JOBSHEADER) \
+        $(OPERATIONSHEADER) \
+        $(HELPERHEADER) \
+        $(CONTROLLERHEADER) \
+        $(POOLWORKERHEADER) \
+        $(SERVERHEADER) \
+        $(WORKERHEADER)
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libFragmentationAutomation_la_SOURCES = 
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libFragmentationAutomation_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libFragmentationAutomation_libincludedir = $(includedir)/Fragmentation/Automation
+nobase_libFragmentationAutomation_libinclude_HEADERS = \
+        $(JOBSHEADER) \
+        $(OPERATIONSHEADER) \
+        $(HELPERHEADER) \
+        $(CONTROLLERHEADER) \
+        $(POOLWORKERHEADER) \
+        $(SERVERHEADER) \
+        $(WORKERHEADER) \
+        $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+#pkgconfigdir = $(libdir)/pkgconfig
+#pkgconfig_DATA = $(top_builddir)/molecuilder.pc $(top_builddir)/molecuilder-debug.pc
+
 include unittests/Makefile.am
 